/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * HarvestItem
 */

public class HarvestItem {
  @JsonProperty("args")
  private List<String> args = null;

  @JsonProperty("created")
  private LocalDateTime created = null;

  @JsonProperty("dataset")
  private Object dataset = null;

  @JsonProperty("ended")
  private LocalDateTime ended = null;

  @JsonProperty("errors")
  private List<HarvestError> errors = null;

  @JsonProperty("kwargs")
  private Object kwargs = null;

  @JsonProperty("remote_id")
  private String remoteId = null;

  @JsonProperty("started")
  private LocalDateTime started = null;

  /**
   * The item status
   */
  public enum StatusEnum {
    PENDING("pending"),

    STARTED("started"),

    DONE("done"),

    FAILED("failed"),

    SKIPPED("skipped"),

    ARCHIVED("archived");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StatusEnum fromValue(String text) {
      for (StatusEnum b : StatusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("status")
  private StatusEnum status = null;

  public HarvestItem args(List<String> args) {
    this.args = args;
    return this;
  }

  public HarvestItem addArgsItem(String argsItem) {
    if (this.args == null) {
      this.args = new ArrayList<String>();
    }
    this.args.add(argsItem);
    return this;
  }

   /**
   * The item positional arguments
   * @return args
  **/
  @ApiModelProperty(value = "The item positional arguments")
  public List<String> getArgs() {
    return args;
  }

  public void setArgs(List<String> args) {
    this.args = args;
  }

  public HarvestItem created(LocalDateTime created) {
    this.created = created;
    return this;
  }

   /**
   * The item creation date
   * @return created
  **/
  @ApiModelProperty(required = true, value = "The item creation date")
  public LocalDateTime getCreated() {
    return created;
  }

  public void setCreated(LocalDateTime created) {
    this.created = created;
  }

  public HarvestItem dataset(Object dataset) {
    this.dataset = dataset;
    return this;
  }

   /**
   * The processed dataset
   * @return dataset
  **/
  @ApiModelProperty(value = "The processed dataset")
  public Object getDataset() {
    return dataset;
  }

  public void setDataset(Object dataset) {
    this.dataset = dataset;
  }

  public HarvestItem ended(LocalDateTime ended) {
    this.ended = ended;
    return this;
  }

   /**
   * The item end date
   * @return ended
  **/
  @ApiModelProperty(value = "The item end date")
  public LocalDateTime getEnded() {
    return ended;
  }

  public void setEnded(LocalDateTime ended) {
    this.ended = ended;
  }

  public HarvestItem errors(List<HarvestError> errors) {
    this.errors = errors;
    return this;
  }

  public HarvestItem addErrorsItem(HarvestError errorsItem) {
    if (this.errors == null) {
      this.errors = new ArrayList<HarvestError>();
    }
    this.errors.add(errorsItem);
    return this;
  }

   /**
   * The item errors
   * @return errors
  **/
  @ApiModelProperty(value = "The item errors")
  public List<HarvestError> getErrors() {
    return errors;
  }

  public void setErrors(List<HarvestError> errors) {
    this.errors = errors;
  }

  public HarvestItem kwargs(Object kwargs) {
    this.kwargs = kwargs;
    return this;
  }

   /**
   * The item keyword arguments
   * @return kwargs
  **/
  @ApiModelProperty(value = "The item keyword arguments")
  public Object getKwargs() {
    return kwargs;
  }

  public void setKwargs(Object kwargs) {
    this.kwargs = kwargs;
  }

  public HarvestItem remoteId(String remoteId) {
    this.remoteId = remoteId;
    return this;
  }

   /**
   * The item remote ID to process
   * @return remoteId
  **/
  @ApiModelProperty(required = true, value = "The item remote ID to process")
  public String getRemoteId() {
    return remoteId;
  }

  public void setRemoteId(String remoteId) {
    this.remoteId = remoteId;
  }

  public HarvestItem started(LocalDateTime started) {
    this.started = started;
    return this;
  }

   /**
   * The item start date
   * @return started
  **/
  @ApiModelProperty(value = "The item start date")
  public LocalDateTime getStarted() {
    return started;
  }

  public void setStarted(LocalDateTime started) {
    this.started = started;
  }

  public HarvestItem status(StatusEnum status) {
    this.status = status;
    return this;
  }

   /**
   * The item status
   * @return status
  **/
  @ApiModelProperty(example = "pending", required = true, value = "The item status")
  public StatusEnum getStatus() {
    return status;
  }

  public void setStatus(StatusEnum status) {
    this.status = status;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    HarvestItem harvestItem = (HarvestItem) o;
    return Objects.equals(this.args, harvestItem.args) &&
        Objects.equals(this.created, harvestItem.created) &&
        Objects.equals(this.dataset, harvestItem.dataset) &&
        Objects.equals(this.ended, harvestItem.ended) &&
        Objects.equals(this.errors, harvestItem.errors) &&
        Objects.equals(this.kwargs, harvestItem.kwargs) &&
        Objects.equals(this.remoteId, harvestItem.remoteId) &&
        Objects.equals(this.started, harvestItem.started) &&
        Objects.equals(this.status, harvestItem.status);
  }

  @Override
  public int hashCode() {
    return Objects.hash(args, created, dataset, ended, errors, kwargs, remoteId, started, status);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class HarvestItem {\n");

    sb.append("    args: ").append(toIndentedString(args)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    dataset: ").append(toIndentedString(dataset)).append("\n");
    sb.append("    ended: ").append(toIndentedString(ended)).append("\n");
    sb.append("    errors: ").append(toIndentedString(errors)).append("\n");
    sb.append("    kwargs: ").append(toIndentedString(kwargs)).append("\n");
    sb.append("    remoteId: ").append(toIndentedString(remoteId)).append("\n");
    sb.append("    started: ").append(toIndentedString(started)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

